#include "stdafx.h"
#include "StringUtil.h"

void Format(string& strBuff, const char *format, ...)
{
	va_list params;

	va_start(params, format);
	int iResult;
	char *buff;
	int length = _vscprintf(format, params);
	buff = new char [length + 1];
	iResult = vsprintf_s(buff, length + 1, format, params);
	buff[length] = '\0';
	if (buff != NULL) {
		strBuff = buff;
		delete[] buff;
	}

	va_end(params);
}

void Format(wstring& strBuff, const WCHAR *format, ...)
{
	va_list params;

	va_start(params, format);

	int iResult;
	WCHAR *buff;
	int length = _vscwprintf(format, params);
	buff = new WCHAR [length + 1];
	iResult = vswprintf_s(buff, length + 1, format, params);
	buff[length] = '\0';
	if (buff != NULL) {
		strBuff = buff;
		delete[] buff;
	}

    va_end(params);
}

void Replace(string& strBuff, const string strOld, const string strNew)
{
	string::size_type Pos = 0;
	string::size_type OldPos = 0;

	while ((Pos = strBuff.find(strOld,OldPos)) != string::npos)
	{
		strBuff.replace(Pos,strOld.size(),strNew);
		OldPos = Pos + strNew.size();
	}
}

void Replace(wstring& strBuff, const wstring strOld, const wstring strNew)
{
	string::size_type Pos = 0;
	string::size_type OldPos = 0;

	while ((Pos = strBuff.find(strOld,OldPos)) != string::npos)
	{
		strBuff.replace(Pos,strOld.size(),strNew);
		OldPos = Pos + strNew.size();
	}
}

void WtoA(wstring strIn, string& strOut)
{
	if( strIn.empty() == true ){
		return ;
	}
	int iLen = 0;
	iLen = WideCharToMultiByte( 932, 0, strIn.c_str(), -1, NULL, 0, NULL, NULL );
	char* pszBuff = new char[iLen+1];
	ZeroMemory(pszBuff, sizeof(char)*(iLen+1));
	WideCharToMultiByte( 932, 0, strIn.c_str(), -1, pszBuff, iLen, NULL, NULL );
	strOut = pszBuff;
	
	delete[] pszBuff;
}

void AtoW(string strIn, wstring& strOut)
{
	if( strIn.empty() == true ){
		return ;
	}
	int iLen = MultiByteToWideChar( 932, 0, strIn.c_str(), -1, NULL, 0 );
	WCHAR* pwszBuff = new WCHAR[iLen+1];
	ZeroMemory(pwszBuff, sizeof(WCHAR)*(iLen+1));
	MultiByteToWideChar( 932, 0, strIn.c_str(), -1, pwszBuff, iLen );

	strOut = pwszBuff;
	
	delete[] pwszBuff;
}

BOOL Separate(string strIn, string strSep, string& strLeft, string& strRight)
{
	if( strIn.empty() == true ){
		return FALSE;
	}
	
	strLeft = "";
	strRight = "";
	int iPos = (int)strIn.find(strSep);
	if( iPos == (int)string::npos ){
		strLeft = strIn;
		return FALSE;
	}else if( iPos == 0 ){
		strIn.erase(0, iPos+strSep.length());
		strRight = strIn;
		return TRUE;
	}
	strLeft = strIn.substr(0,iPos);
	strIn.erase(0, iPos+strSep.length());
	strRight = strIn;
	
	return TRUE;
}

BOOL Separate(wstring strIn, wstring strSep, wstring& strLeft, wstring& strRight)
{
	if( strIn.empty() == true ){
		return FALSE;
	}
	
	strLeft = L"";
	strRight = L"";
	int iPos = (int)strIn.find(strSep);
	if( iPos == (int)string::npos ){
		strLeft = strIn;
		return FALSE;
	}else if( iPos == 0 ){
		strIn.erase(0, iPos+strSep.length());
		strRight = strIn;
		return TRUE;
	}
	strLeft = strIn.substr(0,iPos);
	strIn.erase(0, iPos+strSep.length());
	strRight = strIn;
	
	return TRUE;
}

void ChkFolderPath(string& strPath)
{
	if( strPath.empty() == true ){
		return ;
	}
	string strChk = "\\";
	if( strChk.compare(strPath.substr(strPath.length()-1, 1)) == 0 ){
		strPath.erase(strPath.length()-1, 1);
	}
}

void ChkFolderPath(wstring& strPath)
{
	if( strPath.empty() == true ){
		return ;
	}
	wstring strChk = L"\\";
	if( strChk.compare(strPath.substr(strPath.length()-1, 1)) == 0 ){
		strPath.erase(strPath.length()-1, 1);
	}
}

